from django.urls import reverse_lazy
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views import generic
from asset.models import Asset
from django.shortcuts import get_object_or_404, reverse
from django.http import HttpResponse, HttpResponseRedirect


class AssetCreateView(CreateView):
    model = Asset
    fields = ['named_id', 'description', 'quantity']

    def form_valid(self, form):
        form.instance.changed_by = self.request.user
        form.instance.created_by = self.request.user
        return super().form_valid(form)


class AssetUpdateView(UpdateView):
    model = Asset
    fields = ['named_id', 'description', 'quantity']

    def form_valid(self, form):
        form.instance.changed_by = self.request.user
        return super().form_valid(form)


class AssetDeleteView(DeleteView):
    model = Asset
    success_url = reverse_lazy('asset:list')


class AssetListView(generic.ListView):
    template_name = 'asset/asset_list.html'
    context_object_name = 'asset_list'
    model = Asset
    paginate_by = 20

    """
    def get_queryset(self):
        # Return the last 20 created containers
        return Asset.objects.order_by('-created_ts')[:20]
    """


def asset_save(request, asset_id):
    asset = get_object_or_404(Asset, pk=asset_id)
    asset.description = request.POST['description']
    asset.quantity = request.POST['quantity']
    asset.save();
    return HttpResponseRedirect(reverse('asset:list'))
